

#property indicator_separate_window
#property indicator_minimum -100.0
#property indicator_maximum 100.0
#property indicator_levelcolor Red
#property indicator_width1 2
#property indicator_level1 80.0
#property indicator_level2 -80.0

extern string ModeTravail = "Buy at -100% and Sell at 100%";
extern string TradeMode = "Choose Trading Method : ";
extern bool Scalping = TRUE;
extern string IndColor = "Choose Indicator color : ";
extern color Couleur = Blue;
extern bool SoundON = TRUE;
double Indicator_Buffer[];
double High_Level[];
double Low_Level[];
double MedianPrice;
double restpoint;
double divisor;
static double Time_Bar;
int points = 5;
int start;
int index;
int period;
int Bars_Counted;
int Rest_Bars;

int init() {
   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_LINE, EMPTY, 2, Couleur);
   SetIndexBuffer(0, Indicator_Buffer);
   SetIndexBuffer(1, Low_Level);
   SetIndexBuffer(2, High_Level);
   IndicatorShortName("Vostro     ");
   Time_Bar = Time[0];
   
   return (0);
}

int deinit() {

ObjectsDeleteAll();
   return (0);
}

int start() {

        

   if (Scalping == TRUE) period = 100;
   else period = 300;
   
   Bars_Counted = IndicatorCounted();
   if (Bars_Counted < 0) return (-1);
   if (Bars_Counted > 0) Bars_Counted--;
   int Rest_Bars = Bars + 1 - Bars_Counted;
   
   for (index = 0; index < Rest_Bars; index++) {
   
      MedianPrice = 0;
      for (start = index; start < points + index; start++) MedianPrice += (High[start] + Low[start]) / 2.0;
      restpoint = MedianPrice / points;
      MedianPrice = 0;
      for (start = index; start < points + index; start++) MedianPrice += High[start] - Low[start];
      divisor = 0.2 * (MedianPrice / points);
      Low_Level[index] = (Low[index] - restpoint) / divisor;
      High_Level[index] = (High[index] - restpoint) / divisor;
      if (High_Level[index] > 8.0 && High[index] > iMA(NULL, 0, period, 0, MODE_LWMA, PRICE_MEDIAN, index)) {
	      Indicator_Buffer[index] = 90.0;    
	      	      
	      ObjectCreate("up_1"+Time[index], OBJ_ARROW, 0, Time[index], High[index]+200*Point);
         ObjectSet("up_1"+Time[index], OBJPROP_STYLE, STYLE_DOT);
         ObjectSet("up_1"+Time[index], OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
         ObjectSet("up_1"+Time[index], OBJPROP_WIDTH, 3);
         ObjectSet("up_1"+Time[index], OBJPROP_COLOR, Red);
         
      }
      else {
         if (Low_Level[index] < -8.0 && Low[index] < iMA(NULL, 0, period, 0, MODE_LWMA, PRICE_MEDIAN, index)) {
	         Indicator_Buffer[index] = -90.0;
	         ObjectCreate("down_1"+Time[index], OBJ_ARROW, 0, Time[index], Low[index]-200*Point);
            ObjectSet("down_1"+Time[index], OBJPROP_STYLE, STYLE_DOT);
            ObjectSet("down_1"+Time[index], OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
            ObjectSet("down_1"+Time[index], OBJPROP_WIDTH, 3);
            ObjectSet("down_1"+Time[index], OBJPROP_COLOR, Lime);
        }
         else 
         {
         Indicator_Buffer[index] = 0.0;
         
         }
      }
     
      
      if (High_Level[index] > 8.0 && High_Level[index - 1] > 8.0) {
	      Indicator_Buffer[index] = 0;
	      ObjectDelete("up_1"+Time[index]);
	      ObjectDelete("down_1"+Time[index]);
	      if (SoundON == TRUE && Time_Bar != Time[0]) {
          	Alert("Vostro: Buy!", Symbol(), Period());
            Time_Bar = Time[0];
         }

      }
      if (High_Level[index] > 8.0 && High_Level[index - 1] > 8.0 && High_Level[index - 2] > 8.0) {
	      Indicator_Buffer[index] = 0;
	      ObjectDelete("up_1"+Time[index]);
 	      if (SoundON == TRUE && Time_Bar != Time[0]) {
          	Alert("Vostro: Buy!", Symbol(), Period());
            Time_Bar = Time[0];
         }
     }
      if (Low_Level[index] < -8.0 && Low_Level[index - 1] < -8.0) {
	      Indicator_Buffer[index] = 0;
	      ObjectDelete("down_1"+Time[index]);
 	      if (SoundON == TRUE && Time_Bar != Time[0]) {
          	Alert("Vostro: Sell!", Symbol(), Period());
            Time_Bar = Time[0];
         }
      }
      if (Low_Level[index] < -8.0 && Low_Level[index - 1] < -8.0 && Low_Level[index - 2] < -8.0) {
	      Indicator_Buffer[index] = 0;
	      ObjectDelete("down_1"+Time[index]);
 	      if (SoundON == TRUE && Time_Bar != Time[0]) {
          	Alert("Vostro: Sell!", Symbol(), Period());
            Time_Bar = Time[0];
         }
      }
   }
   return (0);
}